/*  Programa desenvolvido para o PFC do aluno: Davi Pereira Rocha, orientado pelo Prof. Dr. Rubens Barbosa Filho. 
    Este código escreve um programa que utiliza a tecnica da programação dinâmica para o problema do corte guilhotinado bidimensional. 
    30/10/2014. */


#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
 
typedef struct {
        const char * nome;
        int tamanho, prioridade;
} chapa_t;

/* Peças a serem cortadas pela tecnologia. */ 
chapa_t chapa[] = {
        {"Peca 1",                3358,      1},
        {"Peca 2",                3135,      1},
        {"Peca 3",                3066,      1},
        {"Peca 4",                2387,       1},
        {"Peca 5",                2365,       1},
        {"Peca 6",                2160,       1},
        {"Peca 7",                1710,       1},
        {"Peca 8",                1665,       1},
        {"Peca 9",                1300,       1},
        {"Peca 10",               1125,       1},
        {"Peca 11",               949,       1},
        {"Peca 12",               876,       1},
        {"Peca 13",               836,       1},
        {"Peca 14",               540,       1},
        {"Peca 15",               516,       1},
        {"Peca 16",               494,       1},
        {"Peca 17",               440,       1},
        {"Peca 18",               384,       1},
        {"Peca 19",               322,       1},
        {"Peca 20",               300,       1},
        {"Peca 21",               273,       1},
        {"Peca 22",               264,       1},
        {"Peca 23",               221,       1},
        {"Peca 24",               208,       1},
        {"Peca 25",               204,       1},
        {"Peca 26",               195,       1},
        {"Peca 27",               170,       1},
        {"Peca 28",               143,       1},
        {"Peca 29",               130,       1},
        {"Peca 30",               120,       1}
};
 
#define n_chapas (sizeof(chapa)/sizeof(chapa_t))
 
typedef struct {
        uint32_t bits; /* 32 bits, consigo calcular até 32 chapas */
        int prioridade;
} solucao;
 
/* Função recursiva da programação dinâmica. */
/* Os parâmetros da função otimo são o tamanho da área disponível da chapa, o numeros de chapas a serem cortadas. */
void otimo(int tamanho, int idx, solucao *s)
{
        solucao v1, v2;
        if (idx < 0) {
                s->bits = s->prioridade = 0;
                return;
        }
 
        if (tamanho < chapa[idx].tamanho) {
                otimo(tamanho, idx - 1, s);
                return;
         }
 
        otimo(tamanho, idx - 1, &v1);
        otimo(tamanho - chapa[idx].tamanho, idx - 1, &v2);
 
        v2.prioridade += chapa[idx].prioridade;
        v2.bits |= (1 << idx);
 
        *s = (v1.prioridade >= v2.prioridade) ? v1 : v2;
}

/* Função principal. */
int main(void)
{
        int i = 0, w = 0;
        solucao s = {0, 0};
        otimo(10000, n_chapas - 1, &s);
 
        for (i = 0; i < n_chapas; i++) {
                if (s.bits & (1 << i)) {
                        printf("%s\n", chapa[i].nome);
                        w += chapa[i].tamanho;
                }
        }
        printf("Tamanho total(nao ultrapassar o limite 600): %d \n", w);
        return 0;
}
