#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
 
typedef struct {
        const char * nome;
        int tamanho, prioridade;
} chapa_t;
 
chapa_t chapa[] = {
        {"Peca 1",                313644,      1},
        {"Peca 2",                135800,      1},
        {"Peca 3",                129766,      1},
        {"Peca 4",                122508,       1},
        {"Peca 5",                99328,       1},
        {"Peca 6",                97284,       1},
        {"Peca 7",                88830,       1},
        {"Peca 8",                84835,       1},
        {"Peca 9",                65762,       1},
        {"Peca 10",               57730,       1},
        {"Peca 11",               49149,       1},
        {"Peca 12",               41148,       1},
        {"Peca 13",               36716,       1},
        {"Peca 14",              36703,       1},
        {"Peca 15",               35904,       1},
        {"Peca 16",               33840,       1},
        {"Peca 17",               33216,       1},
        {"Peca 18",               28800,       1},
        {"Peca 19",               26304,       1},
        {"Peca 20",             23808,       1},
        {"Peca 21",               22848,       1},
        {"Peca 22",               22002,       1},
        {"Peca 23",               21120,       1},
        {"Peca 24",               18354,       1},
        {"Peca 25",               18300,       1},
        {"Peca 26",              18200,       1},
        {"Peca 27",              14274,       1},
        {"Peca 28",              13800,       1},
        {"Peca 29",              13700,       1},
        {"Peca 30",              13221,       1}
};
 
#define n_chapas (sizeof(chapa)/sizeof(chapa_t))
 
typedef struct {
        uint32_t bits; /* 32 bits, consigo calcular até 32 chapas */
        int prioridade;
} solucao;
 
 
void otimo(int tamanho, int idx, solucao *s)
{
        solucao v1, v2;
        if (idx < 0) {
                s->bits = s->prioridade = 0;
                return;
        }
 
        if (tamanho < chapa[idx].tamanho) {
                otimo(tamanho, idx - 1, s);
                return;
         }
 
        otimo(tamanho, idx - 1, &v1);
        otimo(tamanho - chapa[idx].tamanho, idx - 1, &v2);
 
        v2.prioridade += chapa[idx].prioridade;
        v2.bits |= (1 << idx);
 
        *s = (v1.prioridade >= v2.prioridade) ? v1 : v2;
}
 
int main(void)
{
        int i = 0, w = 0;
        solucao s = {0, 0};
        otimo(1000000, n_chapas - 1, &s);
 
        for (i = 0; i < n_chapas; i++) {
                if (s.bits & (1 << i)) {
                        printf("%s\n", chapa[i].nome);
                        w += chapa[i].tamanho;
                }
        }
        printf("Tamanho total(nao ultrapassar o limite 600): %d \n", w);
        return 0;
}
