#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
 
typedef struct {
        const char * nome;
        int tamanho, prioridade;
} chapa_t;
 
chapa_t chapa[] = {
        {"Peca 1",                1422,      1},
        {"Peca 2",                1302,      1},
        {"Peca 3",                972,      1},
        {"Peca 4",                840,       1},
        {"Peca 5",                696,       1},
        {"Peca 6",                608,       1},
        {"Peca 7",                572,       1},
        {"Peca 8",                546,       1},
        {"Peca 9",                516,       1},
        {"Peca 10",               492,       1},
        {"Peca 11",               456,       1},
        {"Peca 12",               406,       1},
        {"Peca 13",               396,       1},
        {"Peca 14",               378,       1},
        {"Peca 15",               372,       1},
        {"Peca 16",               360,       1},
        {"Peca 17",               348,       1},
        {"Peca 18",               336,       1},
        {"Peca 19",               330,       1},
        {"Peca 20",               312,       1},
        {"Peca 21",               300,       1},
        {"Peca 22",               252,       1},
        {"Peca 23",               208,       1},
        {"Peca 24",               198,       1},
        {"Peca 25",               195,       1},
        {"Peca 26",               182,       1},
        {"Peca 27",               180,       1},
        {"Peca 28",               170,       1},
        {"Peca 29",               150,       1},
        {"Peca 30",               140,       1}
};
 
#define n_chapas (sizeof(chapa)/sizeof(chapa_t))
 
typedef struct {
        uint32_t bits; /* 32 bits, consigo calcular até 32 chapas */
        int prioridade;
} solucao;
 
 
void otimo(int tamanho, int idx, solucao *s)
{
        solucao v1, v2;
        if (idx < 0) {
                s->bits = s->prioridade = 0;
                return;
        }
 
        if (tamanho < chapa[idx].tamanho) {
                otimo(tamanho, idx - 1, s);
                return;
         }
 
        otimo(tamanho, idx - 1, &v1);
        otimo(tamanho - chapa[idx].tamanho, idx - 1, &v2);
 
        v2.prioridade += chapa[idx].prioridade;
        v2.bits |= (1 << idx);
 
        *s = (v1.prioridade >= v2.prioridade) ? v1 : v2;
}
 
int main(void)
{
        int i = 0, w = 0;
        solucao s = {0, 0};
        otimo(10000, n_chapas - 1, &s);
 
        for (i = 0; i < n_chapas; i++) {
                if (s.bits & (1 << i)) {
                        printf("%s\n", chapa[i].nome);
                        w += chapa[i].tamanho;
                }
        }
        printf("Tamanho total(nao ultrapassar o limite 600): %d \n", w);
        return 0;
}
