#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
 
typedef struct {
        const char * nome;
        int tamanho, prioridade;
} chapa_t;
 
chapa_t chapa[] = {
        {"Peca 1",                3780,      1},
        {"Peca 2",                3640,      1},
        {"Peca 3",                2848,      1},
        {"Peca 4",                2403,       1},
        {"Peca 5",                2387,       1},
        {"Peca 6",                1960,       1},
        {"Peca 7",                1827,       1},
        {"Peca 8",                1749,       1},
        {"Peca 9",                1720,       1},
        {"Peca 10",               1584,       1},
        {"Peca 11",               1440,       1},
        {"Peca 12",               1380,       1},
        {"Peca 13",               1254,       1},
        {"Peca 14",               960,       1},
        {"Peca 15",               957,       1},
        {"Peca 16",               946,       1},
        {"Peca 17",               928,       1},
        {"Peca 18",               754,       1},
        {"Peca 19",               649,       1},
        {"Peca 20",               551,       1},
        {"Peca 21",               539,       1},
        {"Peca 22",               462,       1},
        {"Peca 23",               418,       1},
        {"Peca 24",               372,       1},
        {"Peca 25",               360,       1},
        {"Peca 26",               348,       1},
        {"Peca 27",               341,       1},
        {"Peca 28",               319,       1},
        {"Peca 29",               280,       1},
        {"Peca 30",               273,       1}
};
 
#define n_chapas (sizeof(chapa)/sizeof(chapa_t))
 
typedef struct {
        uint32_t bits; /* 32 bits, consigo calcular até 32 chapas */
        int prioridade;
} solucao;
 
 
void otimo(int tamanho, int idx, solucao *s)
{
        solucao v1, v2;
        if (idx < 0) {
                s->bits = s->prioridade = 0;
                return;
        }
 
        if (tamanho < chapa[idx].tamanho) {
                otimo(tamanho, idx - 1, s);
                return;
         }
 
        otimo(tamanho, idx - 1, &v1);
        otimo(tamanho - chapa[idx].tamanho, idx - 1, &v2);
 
        v2.prioridade += chapa[idx].prioridade;
        v2.bits |= (1 << idx);
 
        *s = (v1.prioridade >= v2.prioridade) ? v1 : v2;
}
 
int main(void)
{
        int i = 0, w = 0;
        solucao s = {0, 0};
        otimo(20000, n_chapas - 1, &s);
 
        for (i = 0; i < n_chapas; i++) {
                if (s.bits & (1 << i)) {
                        printf("%s\n", chapa[i].nome);
                        w += chapa[i].tamanho;
                }
        }
        printf("Tamanho total(nao ultrapassar o limite 600): %d \n", w);
        return 0;
}
