#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
 
typedef struct {
        const char * nome;
        int tamanho, prioridade;
} chapa_t;
 
chapa_t chapa[] = {
        {"Peca 1",                7840,      1},
        {"Peca 2",                7380,      1},
        {"Peca 3",                6678,      1},
        {"Peca 4",                6525,       1},
        {"Peca 5",                6160,       1},
        {"Peca 6",                5688,       1},
        {"Peca 7",                4710,       1},
        {"Peca 8",                4500,       1},
        {"Peca 9",                4002,       1},
        {"Peca 10",               3984,       1},
        {"Peca 11",               3350,       1},
        {"Peca 12",               3034,       1},
        {"Peca 13",               2520,       1},
        {"Peca 14",               1976,       1},
        {"Peca 15",               1800,       1},
        {"Peca 16",               1755,       1},
        {"Peca 17",               1628,       1},
        {"Peca 18",               1320,       1},
        {"Peca 19",               1270,       1},
        {"Peca 20",               1260,       1},
        {"Peca 21",               845,       1},
        {"Peca 22",               731,       1},
        {"Peca 23",               720,       1},
        {"Peca 24",               630,       1},
        {"Peca 25",               627,       1},
        {"Peca 26",               624,       1},
        {"Peca 27",               559,       1},
        {"Peca 28",               555,       1},
        {"Peca 29",               480,       1},
        {"Peca 30",               442,       1}
};
 
#define n_chapas (sizeof(chapa)/sizeof(chapa_t))
 
typedef struct {
        uint32_t bits; /* 32 bits, consigo calcular até 32 chapas */
        int prioridade;
} solucao;
 
 
void otimo(int tamanho, int idx, solucao *s)
{
        solucao v1, v2;
        if (idx < 0) {
                s->bits = s->prioridade = 0;
                return;
        }
 
        if (tamanho < chapa[idx].tamanho) {
                otimo(tamanho, idx - 1, s);
                return;
         }
 
        otimo(tamanho, idx - 1, &v1);
        otimo(tamanho - chapa[idx].tamanho, idx - 1, &v2);
 
        v2.prioridade += chapa[idx].prioridade;
        v2.bits |= (1 << idx);
 
        *s = (v1.prioridade >= v2.prioridade) ? v1 : v2;
}
 
int main(void)
{
        int i = 0, w = 0;
        solucao s = {0, 0};
        otimo(20000, n_chapas - 1, &s);
 
        for (i = 0; i < n_chapas; i++) {
                if (s.bits & (1 << i)) {
                        printf("%s\n", chapa[i].nome);
                        w += chapa[i].tamanho;
                }
        }
        printf("Tamanho total(nao ultrapassar o limite 600): %d \n", w);
        return 0;
}
