#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
 
typedef struct {
        const char * nome;
        int tamanho, prioridade;
} chapa_t;
 
chapa_t chapa[] = {
        {"Peca 1",                4760,      1},
        {"Peca 2",                3500,      1},
        {"Peca 3",                3151,      1},
        {"Peca 4",                3124,       1},
        {"Peca 5",                2678,       1},
        {"Peca 6",                2436,       1},
        {"Peca 7",                1989,       1},
        {"Peca 8",                1952,       1},
        {"Peca 9",                1680,       1},
        {"Peca 10",               1568,       1},
        {"Peca 11",               1442,       1},
        {"Peca 12",               1334,       1},
        {"Peca 13",               1248,       1},
        {"Peca 14",               1218,       1},
        {"Peca 15",               1133,       1},
        {"Peca 16",               1044,       1},
        {"Peca 17",               1026,       1},
        {"Peca 18",               966,       1},
        {"Peca 19",               812,       1},
        {"Peca 20",               810,       1},
        {"Peca 21",               783,       1},
        {"Peca 22",               696,       1},
        {"Peca 23",               578,       1},
        {"Peca 24",               572,       1},
        {"Peca 25",               561,       1},
        {"Peca 26",               546,       1},
        {"Peca 27",               336,       1},
        {"Peca 28",               315,       1},
        {"Peca 29",               312,       1},
        {"Peca 30",               288,       1}
};
 
#define n_chapas (sizeof(chapa)/sizeof(chapa_t))
 
typedef struct {
        uint32_t bits; /* 32 bits, consigo calcular até 32 chapas */
        int prioridade;
} solucao;
 
 
void otimo(int tamanho, int idx, solucao *s)
{
        solucao v1, v2;
        if (idx < 0) {
                s->bits = s->prioridade = 0;
                return;
        }
 
        if (tamanho < chapa[idx].tamanho) {
                otimo(tamanho, idx - 1, s);
                return;
         }
 
        otimo(tamanho, idx - 1, &v1);
        otimo(tamanho - chapa[idx].tamanho, idx - 1, &v2);
 
        v2.prioridade += chapa[idx].prioridade;
        v2.bits |= (1 << idx);
 
        *s = (v1.prioridade >= v2.prioridade) ? v1 : v2;
}
 
int main(void)
{
        int i = 0, w = 0;
        solucao s = {0, 0};
        otimo(20000, n_chapas - 1, &s);
 
        for (i = 0; i < n_chapas; i++) {
                if (s.bits & (1 << i)) {
                        printf("%s\n", chapa[i].nome);
                        w += chapa[i].tamanho;
                }
        }
        printf("Tamanho total(nao ultrapassar o limite 600): %d \n", w);
        return 0;
}
