#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
 
typedef struct {
        const char * nome;
        int tamanho, prioridade;
} chapa_t;
 
chapa_t chapa[] = {
        {"Peca 1",                10640,      1},
        {"Peca 2",                10360,      1},
        {"Peca 3",                10140,      1},
        {"Peca 4",                4890,       1},
        {"Peca 5",                3820,       1},
        {"Peca 6",                3744,       1},
        {"Peca 7",                3056,       1},
        {"Peca 8",                2884,       1},
        {"Peca 9",                2656,       1},
        {"Peca 10",               2192,       1},
        {"Peca 11",               2040,       1},
        {"Peca 12",               1952,       1},
        {"Peca 13",               1944,       1},
        {"Peca 14",               1580,       1},
        {"Peca 15",               1560,       1},
        {"Peca 16",               1246,       1},
        {"Peca 17",               1148,       1},
        {"Peca 18",               913,       1},
        {"Peca 19",               882,       1},
        {"Peca 20",               828,       1},
        {"Peca 21",               770,       1},
        {"Peca 22",               660,       1},
        {"Peca 23",               648,       1},
        {"Peca 24",               624,       1},
        {"Peca 25",               574,       1},
        {"Peca 26",               510,       1},
        {"Peca 27",               462,       1},
        {"Peca 28",               432,       1},
        {"Peca 29",               407,       1},
        {"Peca 30",               330,       1}
};
 
#define n_chapas (sizeof(chapa)/sizeof(chapa_t))
 
typedef struct {
        uint32_t bits; /* 32 bits, consigo calcular até 32 chapas */
        int prioridade;
} solucao;
 
 
void otimo(int tamanho, int idx, solucao *s)
{
        solucao v1, v2;
        if (idx < 0) {
                s->bits = s->prioridade = 0;
                return;
        }
 
        if (tamanho < chapa[idx].tamanho) {
                otimo(tamanho, idx - 1, s);
                return;
         }
 
        otimo(tamanho, idx - 1, &v1);
        otimo(tamanho - chapa[idx].tamanho, idx - 1, &v2);
 
        v2.prioridade += chapa[idx].prioridade;
        v2.bits |= (1 << idx);
 
        *s = (v1.prioridade >= v2.prioridade) ? v1 : v2;
}
 
int main(void)
{
        int i = 0, w = 0;
        solucao s = {0, 0};
        otimo(30000, n_chapas - 1, &s);
 
        for (i = 0; i < n_chapas; i++) {
                if (s.bits & (1 << i)) {
                        printf("%s\n", chapa[i].nome);
                        w += chapa[i].tamanho;
                }
        }
        printf("Tamanho total(nao ultrapassar o limite 600): %d \n", w);
        return 0;
}
