#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
 
typedef struct {
        const char * nome;
        int tamanho, prioridade;
} chapa_t;
 
chapa_t chapa[] = {
        {"Peca 1",                8645,      1},
        {"Peca 2",                6450,      1},
        {"Peca 3",                6254,      1},
        {"Peca 4",                5111,       1},
        {"Peca 5",                4455,       1},
        {"Peca 6",                3922,       1},
        {"Peca 7",                3476,       1},
        {"Peca 8",                3402,       1},
        {"Peca 9",                3315,       1},
        {"Peca 10",               3192,       1},
        {"Peca 11",               2970,       1},
        {"Peca 12",               2835,       1},
        {"Peca 13",               2688,       1},
        {"Peca 14",               2673,       1},
        {"Peca 15",               2508,       1},
        {"Peca 16",               2506,       1},
        {"Peca 17",               2025,       1},
        {"Peca 18",               1749,       1},
        {"Peca 19",               1736,       1},
        {"Peca 20",               1694,       1},
        {"Peca 21",               1335,       1},
        {"Peca 22",               1276,       1},
        {"Peca 23",               1264,       1},
        {"Peca 24",               1160,       1},
        {"Peca 25",               1054,       1},
        {"Peca 26",               848,       1},
        {"Peca 27",               629,       1},
        {"Peca 28",               592,       1},
        {"Peca 29",               589,       1},
        {"Peca 30",               407,       1}
};
 
#define n_chapas (sizeof(chapa)/sizeof(chapa_t))
 
typedef struct {
        uint32_t bits; /* 32 bits, consigo calcular até 32 chapas */
        int prioridade;
} solucao;
 
 
void otimo(int tamanho, int idx, solucao *s)
{
        solucao v1, v2;
        if (idx < 0) {
                s->bits = s->prioridade = 0;
                return;
        }
 
        if (tamanho < chapa[idx].tamanho) {
                otimo(tamanho, idx - 1, s);
                return;
         }
 
        otimo(tamanho, idx - 1, &v1);
        otimo(tamanho - chapa[idx].tamanho, idx - 1, &v2);
 
        v2.prioridade += chapa[idx].prioridade;
        v2.bits |= (1 << idx);
 
        *s = (v1.prioridade >= v2.prioridade) ? v1 : v2;
}
 
int main(void)
{
        int i = 0, w = 0;
        solucao s = {0, 0};
        otimo(30000, n_chapas - 1, &s);
 
        for (i = 0; i < n_chapas; i++) {
                if (s.bits & (1 << i)) {
                        printf("%s\n", chapa[i].nome);
                        w += chapa[i].tamanho;
                }
        }
        printf("Tamanho total(nao ultrapassar o limite 600): %d \n", w);
        return 0;
}
