#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
 
typedef struct {
        const char * nome;
        int tamanho, prioridade;
} chapa_t;
 
chapa_t chapa[] = {
        {"Peca 1",                7021,      1},
        {"Peca 2",                6688,      1},
        {"Peca 3",                6248,      1},
        {"Peca 4",                3735,       1},
        {"Peca 5",                3060,       1},
        {"Peca 6",                3030,       1},
        {"Peca 7",                2336,       1},
        {"Peca 8",                2020,       1},
        {"Peca 9",                1804,       1},
        {"Peca 10",               1599,       1},
        {"Peca 11",               1537,       1},
        {"Peca 12",               1480,       1},
        {"Peca 13",               1443,       1},
        {"Peca 14",               1325,       1},
        {"Peca 15",               1152,       1},
        {"Peca 16",               918,       1},
        {"Peca 17",               896,       1},
        {"Peca 18",               795,       1},
        {"Peca 19",               768,       1},
        {"Peca 20",               765,       1},
        {"Peca 21",               689,       1},
        {"Peca 22",               636,       1},
        {"Peca 23",               583,       1},
        {"Peca 24",               576,       1},
        {"Peca 25",               540,       1},
        {"Peca 26",              530,       1},
        {"Peca 27",              525,       1},
        {"Peca 28",              510,       1},
        {"Peca 29",              465,       1},
        {"Peca 30",              384,       1}
};
 
#define n_chapas (sizeof(chapa)/sizeof(chapa_t))
 
typedef struct {
        uint32_t bits; /* 32 bits, consigo calcular até 32 chapas */
        int prioridade;
} solucao;
 
 
void otimo(int tamanho, int idx, solucao *s)
{
        solucao v1, v2;
        if (idx < 0) {
                s->bits = s->prioridade = 0;
                return;
        }
 
        if (tamanho < chapa[idx].tamanho) {
                otimo(tamanho, idx - 1, s);
                return;
         }
 
        otimo(tamanho, idx - 1, &v1);
        otimo(tamanho - chapa[idx].tamanho, idx - 1, &v2);
 
        v2.prioridade += chapa[idx].prioridade;
        v2.bits |= (1 << idx);
 
        *s = (v1.prioridade >= v2.prioridade) ? v1 : v2;
}
 
int main(void)
{
        int i = 0, w = 0;
        solucao s = {0, 0};
        otimo(30000, n_chapas - 1, &s);
 
        for (i = 0; i < n_chapas; i++) {
                if (s.bits & (1 << i)) {
                        printf("%s\n", chapa[i].nome);
                        w += chapa[i].tamanho;
                }
        }
        printf("Tamanho total(nao ultrapassar o limite 600): %d \n", w);
        return 0;
}
